
// ϸ Ddns_Client_Main.c

// ****************************************************
//       
//		Ʈ : Ddns   1.0.0
//		
//		     : Ŭ̾Ʈ (Linux)
//	    
//					Programmed by Codns
//		 
// ****************************************************



#include "Ddns_Client_Header.h"

void ddns_main_interface(DDNS_PARAMETER *, RETURN_PARAMETER *);

// **********************  Լ ****************************

void ddns_main_interface(DDNS_PARAMETER *m_ddns_parameter, RETURN_PARAMETER *m_return_para)
{
	////////////////////////////////////////////////////////////////
	//	 
	////////////////////////////////////////////////////////////////

	struct sockaddr_in server_addr, client_addr; // ּ ü	

	int s_socket; // Ĺ

	int port; //  Ʈȣ

	C_DATA_PACKET Data_Pack;	// Ŭ̾Ʈ    Ŷ

	int return_value = 0;

	char main_svr_ip[16];
	char sub_svr_ip[16];

	char t_str[200];

	int mark_server_type = -1;



	memset(&Data_Pack, '\0', C_DATA_SIZE);
	memset(m_return_para, '\0', RETURN_SIZE);


	///////////////////////////////////////////////////////////////////////


	// Ķ  ȿ üũѴ.	
	if(return_value = check_parameters(m_ddns_parameter))
	{
		m_return_para->r_code = return_value;
		sys_msg_log(m_return_para->r_code, NULL, m_ddns_parameter);
		return;
	}

	if(m_ddns_parameter->s_code[0] != '2') //  ͸ ƴ 츸 α
	{
		memset(t_str, '\0', sizeof(t_str));
		if(strlen(m_ddns_parameter->s_cur_ip) && strlen(m_ddns_parameter->s_nat_check))
		{
			sprintf(t_str, "DDNS CALL : Code[%c], ID[%s], Serial[%s], Domain[%s], Ethernet[%s], IP[%s], NAT[%c]", 
				m_ddns_parameter->s_code[0], m_ddns_parameter->s_user_id, m_ddns_parameter->s_serial, m_ddns_parameter->s_domain, m_ddns_parameter->s_ethernet, m_ddns_parameter->s_cur_ip, m_ddns_parameter->s_nat_check[0]);
		}
		else
		{
			sprintf(t_str, "DDNS CALL : Code[%c], ID[%s], Serial[%s], Domain[%s], Ethernet[%s]", m_ddns_parameter->s_code[0], m_ddns_parameter->s_user_id, m_ddns_parameter->s_serial, m_ddns_parameter->s_domain, m_ddns_parameter->s_ethernet);
		}
		
		sys_msg_log(0, t_str, m_ddns_parameter);
	}

	// ͳ  θ Ȯ. 
	if(return_value = check_network())
	{
		m_return_para->r_code = return_value;
		sys_msg_log(m_return_para->r_code, NULL, m_ddns_parameter);
		return;
	}


	//   
	if(return_value = check_server_ip(main_svr_ip, sub_svr_ip, m_ddns_parameter))
	{
		m_return_para->r_code = return_value;
		sys_msg_log(m_return_para->r_code, NULL, m_ddns_parameter);
		return;
	}


	// eth ּ Ȯ & eth  Ȯ
	if(return_value = check_macaddress(&Data_Pack, m_ddns_parameter->s_ethernet))
	{
		m_return_para->r_code = return_value;
		sys_msg_log(m_return_para->r_code, NULL, m_ddns_parameter);
		return;
	}

	//  ͸  :   ȯ ƴ 
	if((m_ddns_parameter->s_code[0] == '2') && (m_ddns_parameter->s_nat_check[0] == 'N'))
	{
		if(!strcmp(m_ddns_parameter->s_cur_ip, Data_Pack.P_IP))
		{
			m_return_para->r_code = 0;
			return; //   ȵ
		}
		else
		{
			memset(t_str, '\0', sizeof(t_str));
			sprintf(t_str, "IP CHANGED : %s -> %s", m_ddns_parameter->s_cur_ip, Data_Pack.P_IP);
			
			sys_msg_log(IP_CHANGED, t_str, m_ddns_parameter);

			m_ddns_parameter->s_code[0] = '3'; //  Ʈ  ȯ
		}
	}


	do
	{
		mark_server_type = (mark_server_type +1)%2;

		// Ĺ 
		if(return_value = create_socket(&s_socket, &client_addr, Data_Pack.P_IP))
		{
			m_return_para->r_code = return_value;
			sys_msg_log(m_return_para->r_code, NULL, m_ddns_parameter);
			return;
		}


		//  Ʈȣ 
		port = set_port(m_ddns_parameter);	


		//	  Ĺ 
		if(return_value = socket_connect(mark_server_type, &s_socket, &server_addr, main_svr_ip, port))	
		{
			sys_msg_log(return_value, "could not connect with main server", m_ddns_parameter);

			//	  Ĺ  
			//	  Ĺ 
			if(return_value = socket_connect(mark_server_type++ + 1, &s_socket, &server_addr, sub_svr_ip, port))	
			{
				close(s_socket);

				m_return_para->r_code = return_value;
				sys_msg_log(m_return_para->r_code, "could not connect with sub server", m_ddns_parameter);
				//	  Ĺ  

				return;
			}
			else sys_msg_log(0, "connected with sub server", m_ddns_parameter);
		}
		else sys_msg_log(0, "connected with main server", m_ddns_parameter);


		if(return_value = data_recieve(&s_socket, &Data_Pack, m_ddns_parameter, m_return_para))	//	 Ŭ̾Ʈ  
		{
			close(s_socket);
			if(m_ddns_parameter->s_code[0] == '2' && return_value == IP_CHANGED)
			{
				m_ddns_parameter->s_code[0] = '3';
			}
			else
			{				
				m_return_para->r_code = return_value;
				sys_msg_log(m_return_para->r_code, NULL, m_ddns_parameter);
				return;
			}
		}

		//  ͸  :   ȯ 
		if(m_ddns_parameter->s_code[0] == '2')
		{
			close(s_socket);
			m_return_para->r_code = 0;
			return; //   ȵ
		}

		if(m_ddns_parameter->s_code[0] != '3')
		{
			return_value = standby(&s_socket, &Data_Pack, m_ddns_parameter, m_return_para);	//   Ŭ̾Ʈ  

			close(s_socket);
		}
		sleep(10);

	}while(return_value == DISCONNECTED_FROM_SERVER || return_value == RECIEVE_TIMEOUT || return_value == IP_CHANGED);



	m_return_para->r_code = return_value;
	sys_msg_log(m_return_para->r_code, "exit process", m_ddns_parameter);
	return;

}
