
// ϸ Ddns_Client_Socket.c

// ****************************************************
//       
//		Ʈ : Ddns   1.0.0
//		
//		     : Ŭ̾Ʈ (LINUX)
//	    
//					Programmed by Codns
//		 
// ****************************************************



#include "Ddns_Client_Header.h"





// *********************** Լ   ************************


int check_server_ip(char *, char *, DDNS_PARAMETER *);	//	  
int check_network(void);								//	ͳ  üũ
int create_socket(int *, struct sockaddr_in *, char *);				//	Ĺ 
int socket_connect(int, int *, struct sockaddr_in *, char *, int);	//	 


int data_recieve(int *, C_DATA_PACKET *, DDNS_PARAMETER *, RETURN_PARAMETER *);	//	 Ŭ̾Ʈ  
int standby(int *, C_DATA_PACKET *, DDNS_PARAMETER *, RETURN_PARAMETER *);		//	  Ŭ̾Ʈ  



// *************************************
//
//	  Ŭ̾Ʈ  
//	int standby(int *, C_DATA_PACKET *, DDNS_PARAMETER *, RETURN_PARAMETER *);
//
// *************************************

int standby(int *_t_socket, C_DATA_PACKET *t_P_Data_Pack, DDNS_PARAMETER *t_m_ddns_parameter, RETURN_PARAMETER *t_m_return_para) //	  Ŭ̾Ʈ  
{

	int maxfd, i, return_value;       // selectԼ ڵ鸵 descriptor 

	fd_set read_fds; // select Ư  ϵ ȣ ũǴ 		

	struct timeval tv; //   ð  뵵



	FD_ZERO(&read_fds);

//	FD_SET(0, &read_fds);	
	
	FD_SET(*_t_socket, &read_fds);			

	maxfd = *_t_socket + 1;


	tv.tv_sec = 30; // 30 
	tv.tv_usec = 0;


	// κ Ÿ  
	i = select(maxfd, &read_fds, (fd_set*)0, (fd_set*)0, &tv);

	if(i < 0) 
	{
		return SELECT_FUNC_ERROR;
	}	
	else if(i == 0) //  ð ʰ,
	{
		return RECIEVE_TIMEOUT;	
	}
	else
	{
		if(FD_ISSET(*_t_socket, &read_fds)) // κ Ÿ 
		{
			if(return_value = data_recieve(_t_socket, t_P_Data_Pack, t_m_ddns_parameter, t_m_return_para))	//  κ ۹ ͸ о.
			{
				//  Ŭ̾Ʈ   
				return return_value;	
			}
		}
	}
	return 0;	
}




// *************************************
//
//	 Ŭ̾Ʈ  
//	int data_recieve(int *, C_DATA_PACKET *, DDNS_PARAMETER *, RETURN_PARAMETER *);
//
// *************************************

int data_recieve(int *t_socket, C_DATA_PACKET *P_Data_Pack, DDNS_PARAMETER *_m_ddns_parameter, RETURN_PARAMETER *_m_return_para)	//	 Ŭ̾Ʈ  
{
	STOC_DATA_PACKET S2C_Pack;	// κ Ŭ̾Ʈ  Ŷ
	CTOS_DATA_PACKET C2S_Pack;	// Ŭ̾Ʈκ   Ŷ

	char t_str[200];


	memset(&S2C_Pack, '\0', S2C_SIZE);
	memset(&C2S_Pack, '\0', C2S_SIZE);
	
	if(recv(*t_socket, &S2C_Pack, S2C_SIZE,0) > 0)
	{
		if(_m_ddns_parameter->s_code[0] != '2') //  ͸ ƴ 츸 α
		{
			memset(t_str, '\0', sizeof(t_str));
			sprintf(t_str, "RECV DATA FROM SRV : Code[%c]", S2C_Pack.Code[0]);
			
			sys_msg_log(0, t_str, _m_ddns_parameter);
		}

		switch(S2C_Pack.Code[0])
		{
			case '1': //  ͸   
			case 'a': //  ӵǾ.     .
			{
				if(_m_ddns_parameter->s_code[0] == '2') //  ͸  Ȯ
				{
					if(!strcmp(_m_ddns_parameter->s_cur_ip, S2C_Pack.IP))	return 0;//   ȵ
					else
					{
						memset(t_str, '\0', sizeof(t_str));
						sprintf(t_str, "IP CHANGED : %s -> %s", _m_ddns_parameter->s_cur_ip, S2C_Pack.IP);

						sys_msg_log(IP_CHANGED, t_str, _m_ddns_parameter);

						return IP_CHANGED; //  
					}
				}		
				
				//////////////////////////////////////////////
				// Ŭ̾Ʈ -->   Ŷ ۼ
				//////////////////////////////////////////////
				
				C2S_Pack.Code[0] = _m_ddns_parameter->s_code[0]; // ɾ ڵ

				//  뿩 Ȯ
				if(strcmp(P_Data_Pack->P_IP, S2C_Pack.IP))	
				{
					C2S_Pack.NAT_Check[0] = 'Y';
				}
				else	C2S_Pack.NAT_Check[0] = 'N'; //  .		
				
				strcpy(C2S_Pack.IP,  S2C_Pack.IP); 	//   ܺ  	
				strcpy(C2S_Pack.Version, VERSION);		// Ŭ̾Ʈ α׷ 				
				strcpy(C2S_Pack.Physical_Address, P_Data_Pack->Physical_Address);	// ƾ巹	
				strcpy(C2S_Pack.Domain, _m_ddns_parameter->s_domain); // 
				strcpy(C2S_Pack.user_id, _m_ddns_parameter->s_user_id);		// ̵ --> 24
				strcpy(C2S_Pack.password, _m_ddns_parameter->s_password);// ȣ 12
				strcpy(C2S_Pack.serial, _m_ddns_parameter->s_serial);// ø ѹ 12

				// ȯ
				_m_return_para->r_nat_check[0] = C2S_Pack.NAT_Check[0];
				strcpy(_m_return_para->r_cur_ip, C2S_Pack.IP);

				//////////////////////////////////////////////

				if(send(*t_socket, &C2S_Pack, C2S_SIZE, 0) < 0) return DATA_SEND_ERROR;
				if(_m_ddns_parameter->s_code[0] != '2') //  ͸ ƴ 츸 α
				{
					memset(t_str, '\0', sizeof(t_str));
					sprintf(t_str, "SEND DATA TO SRV : Code[%c], ID(%s) Serial(%s) Domain[%s], MAC[%s], IP[%s], NAT[%c]", 
						C2S_Pack.Code[0], C2S_Pack.user_id, C2S_Pack.serial, C2S_Pack.Domain, C2S_Pack.Physical_Address, C2S_Pack.IP, C2S_Pack.NAT_Check[0]);
					
					sys_msg_log(0, t_str, _m_ddns_parameter);
				}

			} // case 'a':
			break;			

			case 'b': return 0;	//  Ʈ Ϸ			
			
			case 'c': return CODE_ERROR;  // ڵ , ɾ ڵ  ̻,  ڵ尪 ƴ			
			case 'd': return PACKET_ERROR;// Ŷ   			

			case 'e': return DB_ERROR;// DB ó  
			case 'f': return SERVER_ERROR;//  ó  

			case 'g': return ERROR_USER_ID;	//  ̵
			case 'h': return ERROR_PASSWORD;	// ȣ 
			case 'i': return ERROR_SERIAL;	// ø 

			default : return WRONG_PACKET; //    : ˼   

		} // switch(S2C_Pack.code[0])
	}// if(recv(s_socket, &S2C_Pack, S2C_SIZE,0) > 0)
	else
	{
		return DISCONNECTED_FROM_SERVER;
	}

	return 0;
}




// *************************************
//
//	Ĺ 
//	int socket_connect(int, int *, struct sockaddr_in *, char *, int);
//
// *************************************

int socket_connect(int a, int *t_socket, struct sockaddr_in *t_server_addr, char *T_IP, int T_PORT)
{
/*	struct timeval tv; //   ð  뵵

	//   ð 5 
	tv.tv_sec = 5;
	tv.tv_usec = 0;
	
	setsockopt(*t_socket, SOL_SOCKET, SO_RCVTIMEO, (char *)&tv, sizeof(tv)); //   ð.
*/
	// ***************** ε ּҸ Է ***********************
	
	memset(t_server_addr, '\0', sizeof(struct sockaddr_in));
	t_server_addr->sin_family = AF_INET;
	t_server_addr->sin_addr.s_addr = inet_addr(T_IP);
	t_server_addr->sin_port = htons(T_PORT);
	
	// *****************  Ʈũ  ******************

	if(connect(*t_socket, (struct sockaddr*)t_server_addr, sizeof(struct sockaddr_in)) < 0)
	{
		if(a == 0)		return MAIN_SVR_CONNECT_ERROR;
		else	return SUB_SVR_CONNECT_ERROR;
	}
	return 0;
}


// *************************************
//
//	Ĺ 
//	int create_socket(int *t_socket, struct sockaddr_in *, char *);
//
// *************************************

int create_socket(int *t_socket, struct sockaddr_in *t_client_addr, char *local_ip) //	Ĺ 
{
	// Ĺ  
	if((*t_socket = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		return CREATE_SOCKET_ERROR;
	}

	//	Ư ī带  Ĺ 
	memset(t_client_addr, '\0', sizeof(struct sockaddr_in));
	t_client_addr->sin_family = AF_INET;
	t_client_addr->sin_addr.s_addr = inet_addr(local_ip);
//	t_client_addr->sin_port = NULL;

	if(bind(*t_socket, (struct sockaddr*)t_client_addr, sizeof(struct sockaddr_in)) < 0) 
	{
		close(*t_socket);

		return BIND_SOCKET_ERROR;
	}

	return 0;
}


// *************************************
//
//	ͳ  üũ
//	int check_network(void);
//
// *************************************

int check_network(void) //	ͳ  üũ
{
	if(!gethostbyname("kns.kornet.net") && !gethostbyname("ns.dacom.co.kr"))
	{
		return NETWORK_FAIL;
	}
	return 0;
}


// *************************************
//
//	  
//	int check_server_ip(char *, char *, DDNS_PARAMETER *);
//
// *************************************

int check_server_ip(char *t_main_ip, char *t_sub_ip, DDNS_PARAMETER *_m_ddns_parameter)//	  
{
	struct hostent *h;

	char t_str[200];

	int a = 0;
	int _is_ip, sub_address_is_domain, main_address_is_domain;

	memset(t_main_ip, '\0', sizeof(t_main_ip));
	memset(t_sub_ip, '\0', sizeof(t_sub_ip));


	sub_address_is_domain = 0;
	main_address_is_domain = 0;


	_is_ip = 0;

	_is_ip = check_para_server_address_type(_m_ddns_parameter);

	switch(_is_ip)
	{
		case 1: main_address_is_domain = 1; //   
			break;
		case 2: sub_address_is_domain = 1; //   
			break;
		case 3: // Ѵ 
		{
			main_address_is_domain = 1;
			sub_address_is_domain = 1;
		}
		break;
	}


	if(main_address_is_domain)
	{
		// μ  Ǹ Ӽ Ͽ Ȯ.

		if(((h = gethostbyname(_m_ddns_parameter->s_main_svr)) != NULL))
		{
			strcpy(t_main_ip, inet_ntoa(*((struct in_addr *)h->h_addr)));

			a++;
		}
		else	a--;
	}
	else strcpy(t_main_ip, _m_ddns_parameter->s_main_svr);




	if(sub_address_is_domain)
	{
		if(((h = gethostbyname(_m_ddns_parameter->s_sub_svr)) != NULL))
		{
			strcpy(t_sub_ip, inet_ntoa(*((struct in_addr *)h->h_addr)));

			if(a < 0) strcpy(t_main_ip, t_sub_ip);
		}
		else
		{
			if(a < 0) return CHECK_SERVER_IP_FAIL;
			else strcpy(t_sub_ip, t_main_ip);
		}
	}
	else strcpy(t_sub_ip, _m_ddns_parameter->s_sub_svr);



	memset(t_str, '\0', sizeof(t_str));
	sprintf(t_str, "main server address(%s) : sub server address(%s)", t_main_ip, t_sub_ip);

	sys_msg_log(0, t_str, _m_ddns_parameter);


	return 0;
}
