
// ϸ Ddns_Main_Test_Header.h

// ****************************************************
//       
//		Ʈ : Ddns   1.0.1
//		
//		     : Ŭ̾Ʈ (LINUX)
//	    
//					Programmed by Codns
//		 
// ****************************************************



#ifndef _DDNS_CLIENT_H
#define _DDNS_CLIENT_H


#include <arpa/inet.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <net/if.h> 
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>
#include <sys/ioctl.h> 
#include <sys/socket.h>
#include <sys/stat.h> 
#include <sys/time.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>



#define MAX_ID_LENGTH		24
#define MAX_PASS_LENGTH		12
#define MAX_SERIAL_LENGTH		12
	
#define MAX_DOMAIN_LENGTH 64

///////////////////////////////////////

#define EMPTY_DOMAIN 101			// Ķ  :   
#define EMPTY_ETHERTNET 102			// Ķ  : ̴ ̽  
#define EMPTY_MAIN_IP 103			// Ķ  :    
#define EMPTY_SUB_IP 104			// Ķ  :    
#define C_CODE_PARA_ERROR 105		// Ķ  : ɾ ڵ 
#define EMPTY_IP 106				// Ķ  :   
#define EMPTY_LOG_PATH 107			// Ķ  : α    
#define EMPTY_HOST 108				// Ķ  : ȣƮ  

#define HOST_LENGTH_SHORT 115		// host  Ģ : host   2 ̻̾ .
#define HOST_LENGTH_LONG 116		// host  Ģ : host    30 ̳ .
#define HOST_LETTER_ERROR 117		// host  Ģ :  ڷ ̷ .
#define HOST_HYPHEN_ERROR	118		// host  Ģ : '-'  ̳ ڿ ġ

#define NETWORK_FAIL 121			// Ʈ , ͳ ȵ
#define CHECK_SERVER_IP_FAIL 122	//  ƾ Ȯ 

#define IOCTRL_ERROR 131			// ioctl Լ  : ī   
#define ETHERNET_ERROR 132			// ġϴ ̴ ̽  : ī   

#define CREATE_SOCKET_ERROR 141		// Ĺ  
#define BIND_SOCKET_ERROR 142		// Ĺ bind 
#define MAIN_SVR_CONNECT_ERROR 143	//    
#define SUB_SVR_CONNECT_ERROR 144	//    
#define DATA_SEND_ERROR 145			//    

#define CODE_ERROR 151				// ڵ , ɾ ڵ  ̻,  ڵ尪 ƴ			
#define PACKET_ERROR 152			// Ŷ  

#define ERROR_USER_ID 153 //  ̵
#define ERROR_PASSWORD 154 // ȣ 
#define ERROR_SERIAL 155 // ø 

#define DB_ERROR 161				// DB ó  
#define SERVER_ERROR 162			//  ó  
#define WRONG_PACKET 163			//    : ˼   


#define IP_CHANGED 171				//   -->  Ʈ ʿ

#define DISCONNECTED_FROM_SERVER 181	// κ Ĺ  		
#define SELECT_FUNC_ERROR 182			// DDNS Ŭ̾Ʈ μ  : select Լ 
#define RECIEVE_TIMEOUT 183				//    ð ʰ : 10  κ  ,  õ

///////////////////////////////////////////



// 4.  ġ --> DDNS Ŭ̾Ʈ μ ޵Ǵ 
typedef struct _Ddns_Parameter	//  ġ --> DDNS Ŭ̾Ʈ μ ޵Ǵ 
{
	char s_code[1];				// ɾ :  (1),  ͸(2)
	char s_user_id[MAX_ID_LENGTH+1];   		// ̵ --> 24
	char s_password[MAX_PASS_LENGTH+1]; // ȣ 12
	char s_serial[MAX_SERIAL_LENGTH+1]; // ø ѹ 12
	char s_domain[MAX_DOMAIN_LENGTH+1];		// : codns.com
	char s_ethernet[10];		// ̴ ̽
	char s_main_svr[30];		//    Ȥ  svr1.codns.com
	char s_sub_svr[30];		//    Ȥ  svr2.codns.com
	char s_cur_ip[16];			//  
	char s_nat_check[1];   		//    'Y', 'N'

	char s_log_check[1];   		// α    'Y', 'N'
	char s_log_path[100];		// α    ϸ "c:\\ddns\\ddns_ddns_log"

}DDNS_PARAMETER;


// 5. DDNS Ŭ̾Ʈ μ -->  ġ ޵Ǵ 
typedef struct _Return_Parameter // DDNS Ŭ̾Ʈ μ -->  ġ ޵Ǵ 
{
	int r_code;					// ȯ ڵ
	char r_nat_check[1];   		//   
	char r_cur_ip[16];			//  

}RETURN_PARAMETER;


// ********************************** 
//
//		 ü  
//
// **********************************

#define RETURN_SIZE sizeof(struct _Return_Parameter) //DDNS Ŭ̾Ʈ μ -->  ġ ޵Ǵ 


// ****************************** 
//
//		Ŷ ü 
//
// ******************************




#endif // _DDNS_CLIENT_H
