
// ϸ Ddns_Client_System.c

// ****************************************************
//       
//		Ʈ : Ddns   1.0.0
//		
//		     : Ŭ̾Ʈ (LINUX)
//	    
//					Programmed by Codns
//		 
// ****************************************************



#include "Ddns_Client_Header.h"



// *********************** Լ   ************************

int check_macaddress(struct _C_Data_Packet *, char *);			//  ý ƾ巹 Ȯ

void arrange_macaddress(char *);//  ý ƾ巹 

int set_port(DDNS_PARAMETER *);//  Ʈȣ 

int check_para_hostname(DDNS_PARAMETER *);// Ķ  :   

int check_para_ethernet(DDNS_PARAMETER *);// Ķ  : ̴ ̽ 

int check_para_svr_domain(DDNS_PARAMETER *);// Ķ  :   

int check_para_s_code(DDNS_PARAMETER *);// Ķ  : ɾ ڵ

int check_parameters(DDNS_PARAMETER *);// Ķ  :

int check_para_server_address_type(DDNS_PARAMETER *); // Ķ  :  ּ      ...

int check_domain_format(char *, int);// Ķ  :   




// Ķ  : 
int check_parameters(DDNS_PARAMETER *m_ddns_parameter)
{
	int return_value = 0;

	if(return_value = check_para_s_code(m_ddns_parameter)) return return_value;

	switch(m_ddns_parameter->s_code[0])
	{
		case '1':
		case '2':
		case '3':
		{
			if(return_value = check_para_hostname(m_ddns_parameter)) return return_value;
			if(return_value = check_para_ethernet(m_ddns_parameter)) return return_value;
			if(return_value = check_para_svr_domain(m_ddns_parameter)) return return_value;
		}
	}

	if((m_ddns_parameter->s_code[0] == '2') && !strlen(m_ddns_parameter->s_cur_ip))
	{
		// ý ǿ      ʱȭ.   Ѿ  . ̷   Ʈ ó.
		m_ddns_parameter->s_code[0] = '3';
//		return EMPTY_IP;
	}

	if((m_ddns_parameter->s_log_check[0] == 'Y') && !strlen(m_ddns_parameter->s_log_path))	return EMPTY_LOG_PATH;
	

	return return_value;
}





// Ķ  : ɾ ڵ
int check_para_s_code(DDNS_PARAMETER *_m_ddns_parameter)
{
	switch(_m_ddns_parameter->s_code[0])
	{
		case '1':
		case '2':
		case '3':
		break;
		default:
		{
			return C_CODE_PARA_ERROR;
		}
	}
	return 0;
}

// Ķ  :   
int check_para_svr_domain(DDNS_PARAMETER *_m_ddns_parameter)
{
	if(!strlen(_m_ddns_parameter->s_main_svr)) return EMPTY_MAIN_IP;

	if(!strlen(_m_ddns_parameter->s_sub_svr)) return EMPTY_SUB_IP;

	return 0;
}

// Ķ  : ̴ ̽ 
int check_para_ethernet(DDNS_PARAMETER *_m_ddns_parameter)
{
	if(!strlen(_m_ddns_parameter->s_ethernet)) return EMPTY_ETHERTNET;

	return 0;
}

// Ķ  :   
int check_para_hostname(DDNS_PARAMETER *_m_ddns_parameter)
{
	int d_len = 0;
	int i = 0;

	//   üũ : 2ڿ MAX_ID_LENGTH  

	switch(d_len = check_domain_format(_m_ddns_parameter->s_user_id, MAX_ID_LENGTH))
	{
		case -1 : return EMPTY_HOST;
		case 1 : return HOST_LENGTH_SHORT;
		case 2 : return HOST_LENGTH_LONG;
		case 3 : return HOST_LETTER_ERROR;
		case 4 : return HOST_HYPHEN_ERROR;	
	}

	return 0;
}


// Ķ  :   
int check_domain_format(char *s_hostname, int _max_length)
{
	int d_len = 0;
	int i = 0;

	//   üũ : 2ڿ MAX_HOST_LENGTH  

	switch(d_len = strlen(s_hostname))
	{
		case 0 : return -1;//EMPTY;
		case 1 : return 1;//LENGTH_SHORT;
		default :
		{
			if(d_len > _max_length) return 2;//LENGTH_LONG;
		}
	}

	//   üũ :  ڷθ 

	for(i = 0; i < d_len; i++)
	{
		//ѱ Է 
		if((s_hostname[i] < 0x20)||(s_hostname[i] > 0x7e)) // ȣ 
		{
			return 3;//LETTER_ERROR;			
		}
		else if(!isalnum(s_hostname[i])) //  Ȥ 
		{
			if(s_hostname[i] == '-') // '-' 
			{						
				if((i == 0) || (i == d_len-1))
				{
					return 4;//HYPHEN_ERROR;							
				}
			}					
			else 
			{
				return 3;//LETTER_ERROR;					
			}
		}
	}
	return 0;
}



//  Ʈȣ 
int set_port(DDNS_PARAMETER *_m_ddns_parameter)
{
	if(_m_ddns_parameter->s_code[0] == '2') return MONI_PORT; //  ͸ ͸  
	else return MAIN_PORT;

}



// Ķ  :  ּ      ...
int check_para_server_address_type(DDNS_PARAMETER *_m_ddns_parameter)
{
	int i = 0;
	int d_len = 0;
	int return_value = 0;


	d_len = strlen(_m_ddns_parameter->s_main_svr);

	//   üũ :  

	for(i = 0; i < d_len; i++)
	{
		if(isalpha(_m_ddns_parameter->s_main_svr[i])) //  
		{
			return_value += 1;		//  	

			break;
		}		
	}

	d_len = 0;

	d_len = strlen(_m_ddns_parameter->s_sub_svr);

	//   üũ :  ڷθ 

	for(i = 0; i < d_len; i++)
	{
		if(isalpha(_m_ddns_parameter->s_sub_svr[i])) //  
		{
			return_value += 2;		//  	

			break;
		}		
	}


	return return_value; 
}


// *************************************
//
//  ý ƾ巹 
//	void arrange_macaddress(char *)
//
// *************************************

void arrange_macaddress(char *temp_mac_1)//  ý ƾ巹 
{
	char temp_mac[10][3];	

	int k = 0;
	int j = 0;
	int L = 0;

	memset(temp_mac, '\0', 30);

	for(k = 0; k < 6; k++)
	{
		for(j = 0; temp_mac_1[L] != ':' && j < 2; j++)
		{			
			temp_mac[k][j] = temp_mac_1[L++];
			
		}
		L++;
	}

	memset(temp_mac_1, '\0', 18);

	L = 0;

	for(k = 0; k < 6; k++)
	{
		if(strlen(temp_mac[k]) == 1)
		{
			strcat(temp_mac_1, "0");
			strcat(temp_mac_1, temp_mac[k]);
		}
		else
		{
			strcat(temp_mac_1, temp_mac[k]);
		}
		if(k != 5) strcat(temp_mac_1, ":");		
	}
	return;
}

// *************************************
//
//  ý ƾ巹 Ȯ
//	int check_macaddress(struct _C_Data_Packet *, char *)
//
// *************************************

int check_macaddress(struct _C_Data_Packet *P_Data_Pack, char *t_eth_num) 
{ 
	char Temp_IP[16];
	char Temp_mac[18];

    // ̴  ü 
    struct ifreq *ifr; 
    struct sockaddr_in *sin; 
    struct sockaddr *sa; 

    // ̴  ü 
    struct ifconf ifcfg; 
    int fd; 
    int n; 
    int numreqs = 30; 
    fd = socket(AF_INET, SOCK_DGRAM, 0); 

    // ̴   ؼ 
    //  ü ʱȭϰ  
    // ifreqʹ ifc_buf Ǹ, 
    // Ʈũ ġ    Ƿ ũ⸦  ־ Ѵ.  
    //  ּҿ ϳ ̴ī, 2 ġ . 
    memset(&ifcfg, 0, sizeof(ifcfg)); 
    ifcfg.ifc_buf = NULL; 
    ifcfg.ifc_len = sizeof(struct ifreq) * numreqs; 
    ifcfg.ifc_buf = malloc(ifcfg.ifc_len); 

    for(;;) 
    { 
        ifcfg.ifc_len = sizeof(struct ifreq) * numreqs; 
        ifcfg.ifc_buf = realloc(ifcfg.ifc_buf, ifcfg.ifc_len); 
        if (ioctl(fd, SIOCGIFCONF, (char *)&ifcfg) < 0) 
        { 
			close(fd);
			free(ifcfg.ifc_buf);

			return IOCTRL_ERROR;
        } 
 
        break; 
    } 

    // Ʈũ ġ  ´.  
    //   ϳ ̴ ī带   ̹Ƿ 
    // 2   ̴. 
    ifr = ifcfg.ifc_req; 
    for (n = 0; n < ifcfg.ifc_len; n+= sizeof(struct ifreq)) 
    { 
        // ּҰ  ּ ȮѴ. 
        sin = (struct sockaddr_in *)&ifr->ifr_addr; 

		memset(Temp_IP, '\0', 16);
		strcpy(Temp_IP, inet_ntoa(sin->sin_addr)); 
        
		if(ntohl(sin->sin_addr.s_addr) == INADDR_LOOPBACK) 
        { 
//            printf("Loop Back\n"); 
        } 
        else 
        { 
			if(!strcmp(t_eth_num, ifr->ifr_name)) //  ī  
			{
				// ġ ƴ϶ MAC Ѵ. 
				ioctl(fd, SIOCGIFHWADDR, (char *)ifr); 
				sa = &ifr->ifr_hwaddr; 

				////////////////////////////////////////////////////////////////////////////

				// ī  
				strcpy(P_Data_Pack->P_IP, Temp_IP);


	//			ƾ巹 
				memset(Temp_mac, '\0', 18);

				sprintf(Temp_mac, "%s\0", ether_ntoa((struct ether_addr *)sa->sa_data));

				arrange_macaddress(Temp_mac);

				strcpy(P_Data_Pack->Physical_Address, Temp_mac);	

				close(fd);
				free(ifcfg.ifc_buf);

				return 0;
			}
        }         
        ifr++; 
    }
	close(fd);
	free(ifcfg.ifc_buf);

	return ETHERNET_ERROR;
} 







